/*
 * Licensed under the MIT License.
 *
 * Copyright (c) 2007 Charles D Palen
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */
/*
 * GPS_Assist.java
 *
 * Created on October 17, 2006, 11:28 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package my.GPS_Get;
/* Including access to the serial port and IO properties*/
import java.util.Enumeration;

/**
 *
 * @author Charles
 */
public class GPS_Assist {

        
    /** Creates a new instance of GPS_Assist */
         public GPS_Assist() {
        }
         
        public static String GetSentence() {
        String returnvar = new String("Variable Decloration Blows");
        return returnvar;
        }
        
// ## NAME: Parse_GPS
// ## DATE: 11/19/2006
// ## AUTHOR: Charles Palen
// ## DESCRIPTION: This function executes the operations that get a gps sentence from the serial port.
// ## It examines the gps sentence to see if it is valid or not, then returns a valid GPS or gets attemps to
// ## get a valid gps sentence again.
// ## PRECONDITIONS: A comm port must be sent as a string, and speed as an integer
// ## POSTCONDITIONS: The current valid latitude, longitude, and azemuth (heading relative to a 360 circle) are returned as 0,1,2 of a double array
      public double[] Parse_GPS(String _RAW_NMAE_STRING){
          // Initializing a return value
             double[] Return_GPS = new double[3];
             

         // If we are out of the while loop, it means that GPS_String has recieved a valid GPRMC string.
         // Now manipulating the returned string into coordinates.
         // THE BELOW METHOD OF PARSING IS BASED ON A $GPRMC STRING AND IS NOT DYNAMIC.  N,S,E,W WILL NEED TO BE
         // COMPENSATED FOR LATER.
        if (_RAW_NMAE_STRING != null && _RAW_NMAE_STRING.length() > 42) {
         // Extracting Latitude, Longitude, and true course if available.  If not, extracting Latitude and Longitude.
            if (_RAW_NMAE_STRING.charAt(42) == ','){
              Return_GPS[0] = Double.parseDouble(_RAW_NMAE_STRING.substring(16,25).trim());
              Return_GPS[1] = Double.parseDouble(_RAW_NMAE_STRING.substring(29,38).trim());
              
         // Setting a value for the azemuth that would never happen so that we can check for azemuth in other
         // functions
              Return_GPS[2] = 555555;
            } else {
              Return_GPS[0] = Double.parseDouble(_RAW_NMAE_STRING.substring(16,25).trim());
              Return_GPS[1] = Double.parseDouble(_RAW_NMAE_STRING.substring(29,38).trim());
              Return_GPS[2] = Double.parseDouble(_RAW_NMAE_STRING.substring(47,52).trim());
            }
        } else {
              // Setting the first latitude value to 5, a value it would never get.  Higher functions check for
              // this value in this spot to know that we did not get any gps data.
                 Return_GPS[0] = 5;
        }
            return Return_GPS;
      }

        
// ## NAME: GPS_Distance_Heading
// ## DATE: 11/16/2006
// ## AUTHOR: Charles Palen
// ## DESCRIPTION: This function takes in two sets of coordinates from GPS in the form of ddmm.mm and
// ## reports the distance between the two points and the heading to the second point.
// ## PRECONDITIONS: Two longitude and Latitude pairs are sent to the function in the form ddmm.mm
// ## POSTCONDITIONS: The distance between the two points in miles is returned in spot 0 and heading in degrees in 1  
        public static double[] GPS_Distance_Heading (double IN_LatitudeA, double IN_LongitudeA,double IN_LatitudeB, double IN_LongitudeB){
          // Initializing the return distance and Heading
            double Distance = 0;
            double Heading = 0;
            double[] ReturnArr = new double[2];
            
          // Converting the numbers from ddmm.mmmm format to dd.dddd then to radians
          // Returned as position 0 and 1 in array
             double Lat_Long1_RAD[] = GPS_TO_RAD(IN_LatitudeA,IN_LongitudeA);
             double Lat_Long2_RAD[] = GPS_TO_RAD(IN_LatitudeB,IN_LongitudeB);

          // Using great circle navigation formula on the radian values
             Distance = Math.acos(Math.sin(Lat_Long1_RAD[0]) * Math.sin(Lat_Long2_RAD[0]) + Math.cos(Lat_Long1_RAD[0]) * Math.cos(Lat_Long2_RAD[0]) * Math.cos(Lat_Long1_RAD[1] - Lat_Long2_RAD[1]));
          
          // Now calculating the heading
          // If the sin(longitude2 - longitude1 < 0) it means we need to go the opposite way around a 360 degree circle.
             if ( Math.sin(IN_LongitudeB - IN_LongitudeA) < 0){ 
System.out.println("RAN FIRST HEADING INSTANCE");
                 double t1 = Math.sin(Lat_Long2_RAD[0]) - Math.sin(Lat_Long1_RAD[0]) * Math.cos(Distance);
                 double t2 = Math.cos(Lat_Long1_RAD[0]) * Math.sin(Distance);
                 double t3 = t1 / t2;
                 double t4 = Math.atan(-t3 / Math.sqrt(-t3 * t3 + 1)) + 2 * Math.atan(1);
                 Heading = t4;
               // Heading = Math.acos(Math.sin(Lat_Long2_RAD[0]) - Math.sin(Lat_Long1_RAD[0]) * Math.cos(Distance) / Math.cos(Lat_Long1_RAD[0]) * Math.sin(Distance));
               // Heading = 360 - Heading;
             } else {
System.out.println("RAN SECOND HEADING INSTANCE");
                double t1 = Math.sin(Lat_Long2_RAD[0]) - Math.sin(Lat_Long1_RAD[0]) * Math.cos(Distance);
	        double t2 = Math.cos(Lat_Long1_RAD[0]) * Math.sin(Distance);
	        double t3 = t1 / t2;
	        double t4 = -t3 * t3 + 1;
	        double t5 = 2 * 3.14 - (Math.atan(-t3 / Math.sqrt(-t3 * t3 + 1)) + 2 * Math.atan(1));
                Heading = t5;
                System.out.println("t1 " + t1);
                System.out.println("t2 " + t2);
                System.out.println("t3 " + t3);
                System.out.println("t4 " + t4);
                System.out.println("t5 " + t5);
               // Heading = Math.acos(Math.sin(Lat_Long2_RAD[0]) - Math.sin(Lat_Long1_RAD[0]) * Math.cos(Distance) / Math.cos(Lat_Long1_RAD[0]) * Math.sin(Distance));
             }
          // Distance is still in radians.  Converting to Nautical Miles then to Land Miles
             Distance = (Distance * 3437.7387) * 1.150779;
             
          // Heading is still in radians.  Converting to Degrees
             Heading = Heading * 57.2957795;
             ReturnArr[0] = Distance;
             ReturnArr[1] = Heading;
             
             return ReturnArr;
        }
        
// ## NAME: GPS_TO_RAD
// ## DATE: 11/16/2006
// ## AUTHOR: Charles Palen
// ## DESCRIPTION: This function converts coordinates input from gps
// ## in the form ddmm.mm to dd.dddd then to Radians
// ## PRECONDITIONS: A longitude and Latitude are sent to the function in the form ddmm.mm
// ## POSTCONDITIONS: A double array is returned with the values input converted to radian format
   public static double[] GPS_TO_RAD(double IN_Lat, double IN_Long){
    // Initializing our return array
       double[] Lat_Long_IN_RAD = new double[2];
       
    // Converting from ddmm.mm to dd.dddd
       double LatA = IN_Lat / 100;
       int LatB = (int)LatA;
       Lat_Long_IN_RAD[0] = ((((LatA - LatB) * 100) / 60) + LatB) / 57.3;
       
       double LongA = IN_Long / 100;
       int LongB =(int)LongA;
       Lat_Long_IN_RAD[1] = ((((LongA - LongB) * 100) / 60) + LongB) / 57.3;
       
       return Lat_Long_IN_RAD;
   }

}
